
import gconf

class Configuration :

    def __init__ ( self ) :
        self.homedir = None
        self.dbname = None
        self.mapsdir , self.mapclass = None , None
        self.lat , self.lon = 0.0 , 0.0
        self.zoom = 0
        self.read()

    def read ( self ) :
        client = gconf.client_get_default()
        self.homedir = client.get_string( "/apps/wifihood/basedir" )
        self.dbname = client.get_string( "/apps/wifihood/dbname" )
        self.mapsdir = client.get_string( "/apps/wifihood/maps" )
        self.mapclass = client.get_string( "/apps/wifihood/maptype" )
        self.lat = client.get_float( "/apps/wifihood/lattitude" )
        self.lon = client.get_float( "/apps/wifihood/longitude" )
        self.zoom = client.get_int( "/apps/wifihood/zoom" )

    def save ( self ) :
        client = gconf.client_get_default()
        client.set_string( "/apps/wifihood/basedir" , self.homedir )
        client.set_string( "/apps/wifihood/dbname" , self.dbname )
        client.set_string( "/apps/wifihood/maps" , self.mapsdir )
        client.set_string( "/apps/wifihood/maptype" , self.mapclass )
        client.set_float( "/apps/wifihood/lattitude" , self.lat )
        client.set_float( "/apps/wifihood/longitude" , self.lon )
        client.set_int( "/apps/wifihood/zoom" , self.zoom )


